" - Config -
"" Encoding
set encoding=utf8
"" Disable modeline
set nomodeline
"" System undo levels
set undofile
set undolevels=100
"" Indenting
set tabstop=2
set softtabstop=2
set shiftwidth=2
set expandtab
"" Disable error sounds
set noerrorbells
"" Stop word wrapping
set nowrap
"" Show invisible characters
set conceallevel=1
"" Enable search highlighting
set hlsearch
"" Line Numbers
set number relativenumber
"" Top/Bottom scroll padding
set scrolloff=3
set sidescrolloff=5
"" Enable autoread if file changes
set autoread
"" Map Leader to spacebar
let mapleader=" "

"---"

" Load Plugins
"" Begin vim-plug
call plug#begin('~/.vim/plugged')
"" Visual Plugins
Plug 'dracula/vim'
"" Syntax Plugins
Plug 'dense-analysis/ale'
"" Ease of Editing Plugins
Plug 'tpope/vim-surround'
"" Project/File Navigation Plugins
Plug 'junegunn/fzf', { 'dir': '~/.fzf', 'do': './install --all' }
Plug 'junegunn/fzf.vim'
"" Git
Plug 'tpope/vim-fugitive'
"" Initialize plugin system
call plug#end()

" Config Plugins
"" Colorscheme Dracula
let g:dracula_colorterm = 0 " Set background as transparent
colorscheme dracula
"" FZF
nnoremap <Leader>t :Files<cr>
nnoremap <Leader>T :Buffers<cr>
nnoremap <Leader>g :Ag 
nnoremap <Leader>c :Commits<cr>
nnoremap <Leader>C :BCommits<cr>
nnoremap <Leader>m :GFiles?<cr>
